// SPDX-License-Identifier: GPL-3.0
//
// Copyright (C) 2019, Donald Dugger
//
export function logger(str)
{

  console.log("DDD: " + str);
}

export function pr_object(object) {
  for(var key in object) {
    try {
      logger('  Key: ' + key + ' | value: ' + object[key]);
    } catch (error) {
      // Some values throw an error when trying to access them.
      logger('  Key: ' + key + ' | Error: ' + error.message);
    }
  }
}

// Add zero in front of numbers < 10
export function numPad(i, p) {
  if (i < 10) {
    i = p + i;
  }
  return i;
}

export function milli2str(milli, hundred)
{

  milli = parseInt(milli / 10);
  let sec = parseInt(milli/100);
  let hun = milli - (sec * 100);
  let min = parseInt(sec / 60);
  sec = sec - (min * 60);
  let hr = parseInt(min / 60);
  min -= hr * 60;
  let ret = ".--";
  if (hundred) {
    ret = "." + numPad(hun, "0");
    if (hr == 0 && min == 0)
      return sec + ret;
  }
  ret = numPad(sec, "0") + ret;
  if (hr == 0)
    return min + ":" + ret;
  return hr + ":" + numPad(min, "0") + ":" + ret;
}

export function face(doc)
{
  let bar;

  for (let i = 0; i < 12; i++) {
    bar = doc.getElementById("tick-" + i);
    bar.groupTransform.rotate.angle = (i * 30);
    for (let j = 1; j < 5; j++) {
      bar = doc.getElementById("tock-" + i + "-" + j);
      bar.groupTransform.rotate.angle = (i * 30) + (6 * j);
    }
  }
}

export function btn_paint(btn, icon, color)
{

  let img = btn.getElementById("combo-button-icon");
  img.image = icon;
  img.style.fill = color;
  img = btn.getElementById("combo-button-icon-press");
  img.image = icon;
  img.style.fill = color;
}

export function stop_time(ticks)
{

  let hun = parseInt(ticks / 10);
  let secs = parseInt(hun / 100);
  hun -= secs * 100;
  let mins = parseInt(secs / 60);
  secs -= (mins * 60);
  let hrs = parseInt(mins / 60);
  mins -= hrs * 60;
  return {
    hour: hrs,
    minute: mins,
    second: secs,
    hundred: hun
  };
}

export function rt_clock()
{

  let local = new Date();
  let hr = local.getHours();
  hr = (hr > 12) ? hr - 12 : hr;
  return {
    hour: local.getHours(),
    minute: local.getMinutes(),
    second: local.getSeconds(),
    hundred: 0
  };
}

export function show_numbers(rt, d)
{

  d.getElementById("min-15").text = (rt ?  " 3" : "15");
  d.getElementById("min-30").text = (rt ?  " 6" : "30");
  d.getElementById("min-45").text = (rt ?   "9" : "45");
  d.getElementById("min-60").text = (rt ?  "12" : "60");
  d.getElementById("min-5").style.display =  (rt ? "none" : "inline");
  d.getElementById("min-10").style.display = (rt ? "none" : "inline");
  d.getElementById("min-20").style.display = (rt ? "none" : "inline");
  d.getElementById("min-25").style.display = (rt ? "none" : "inline");
  d.getElementById("min-35").style.display = (rt ? "none" : "inline");
  d.getElementById("min-40").style.display = (rt ? "none" : "inline");
  d.getElementById("min-50").style.display = (rt ? "none" : "inline");
  d.getElementById("min-55").style.display = (rt ? "none" : "inline");
}
